import java.util.*;
import java.io.*;

class Lecteur{
	private HashSet<String> D; // la matrice D de l'enonce
	private NoeudPriorite file_cryptee; // l'ordre dans lequel on va dcrypter le texte donn
	private HashMap<String, LinkedList<permutation>> MotsPossibles;
	private LinkedList<String> texteCrypteComplet;
	HashMap<String, LinkedList<permutation>> getMotsPossibles() {return MotsPossibles;}
	NoeudPriorite getFileLecture() {return file_cryptee;}
	public int nb_lettres_utilisees;
	private int constante_file;
	public void set_constante_file(int n) {constante_file = n;};

	Lecteur() {
		D = new HashSet<String>();
		MotsPossibles = new HashMap<String, LinkedList<permutation>>();
	}

	public void initialise_dico(String fichier_dico) {
		MotsPossibles.clear();
		try {
			Scanner scan = new Scanner(new File(fichier_dico));
			scan.useDelimiter("\n");
			int c=0;
			while (scan.hasNext())
			{
				c++;
				String s = scan.next();
				if (!D.contains(s)) D.add(s);
				String calc = hasher(s);
				if (MotsPossibles.get(calc) == null) 
					MotsPossibles.put(calc, new LinkedList<permutation>());
				try{
				MotsPossibles.get(calc).add(new permutation(calc, s));
				}
				catch(Exception e) {;};
			}			
			System.out.println("Lecture du dictionnaire terminee.\nLe dictionnaire contient "+c+" mots.");
		}
		catch (FileNotFoundException f)
		{
			System.err.println("Fichier dictionnaire incorrect");
		}
		catch (OutOfMemoryError o)
		{ 
			System.err.println("Tout le dictionnaire n'a pas ete enregistre !");
		}
	}
	
	public boolean D_contient_mot (String mot)
	{
		return (D.contains(mot));
	}

// fonction assez importante vue le rle que joue la file de priorit.
// s sera toujours le premier mot de la file. On ne veut insrer des mots que "proches" de s au sens o
// t ne fait intervenir que peu de lettres nouvelles.
	private int distance(String s, String t) { 
	// s sera toujours le meme en pratique
	// par contre si t n'a que les meme lettres que s, ca ne nous intresse pas normment (variable "inclus")
	// meme si c'est purement de la verification => petite sanction
		int[] a = new int[26];
		int[] b = new int[26];

		for(int k = 0; k < s.length(); k++)
			a[s.charAt(k)-'a']++;
		for(int k = 0; k < t.length(); k++)
			b[t.charAt(k)-'a']++;

		int summ = 0;
		boolean inclus = true;
		for(int k = 0; k < 26; k++) {
			if (a[k] != 0 && b[k] == 0) inclus = false;
			if (a[k] != 0)
				summ += Math.abs(a[k] - b[k]);
			else if (b[k] != 0) summ += 10;
		}
		if (inclus) summ +=10;
		return summ;
	}


// initialisation avec un fichier
	public void initialise_crypte(String fichier_crypte, permutation p) {
		try {
			Scanner scan = new Scanner(new File(fichier_crypte));
			initialise(scan, p);
		}
		catch (FileNotFoundException f)
		{
			System.err.println("Fichier du texte crypte incorrect");
		}
	}

// idem mais cette fois texte_crypte n'est pas le nom du fichier, mais le texte lui meme
	public void initialise_crypte2(String texte_crypte, permutation p) { 
		Scanner scan = new Scanner(texte_crypte);
		initialise(scan, p);
	}

// fonction principale
//  partir de la liste des mots possibles associs  un mot chiffr, on construit la file de priorit
// le parcours dfs du dcrypteur parcourera les mots dans l'ordre de cette file
	private void initialise(Scanner scan, permutation p) {
		LinkedList<String> texteCrypte = new LinkedList<String>();
		long temps1 = System.currentTimeMillis();
		texteCrypteComplet = new LinkedList<String>();
		if (!scan.hasNext())
		{	System.err.println("Le message crypte est vide !"); return; }

	// lecture des mots du fichier. cration de la liste des mots possibles simultane
		int nb = 0;
		int c = 0;
		String retient = "";
		boolean[] lettres = new boolean[26];
		for(int k = 0; k < 26; k++)
			lettres[k] = false;
		do
		{
			String s = scan.next();
			for(int i = 0; i < s.length(); i++)
				lettres[s.charAt(i) - 'a'] = true;
			c++;
			int n = NoeudPriorite.calcule(s);
			if (n > nb) {retient = s; nb = n;}
			if (!texteCrypte.contains(s))
				texteCrypte.addLast(s);
			texteCrypteComplet.addLast(s);
		} while (scan.hasNext());
		System.out.println("Le message crypte contient "+c+" mots, dont "+texteCrypte.size()+ " mots a traiter");
		System.out.println("Creation de la liste des mots possibles et de l'ordre de parcours du texte");

	// cration de la file de priorit.
	// principe :
		// d'abord les 10 premiers mots o il y a le moins de possibilits.
		// ensuite, les mots qui comptent les lettres "oublies" dans les 10 premiers mots.
		// si les 10 premiers mots comptent quand meme beaucoup de possibilits, on va garder seulement "retient" (= le premier), et 
		// juste derriere on intercale les 10 premiers mots les plus proches de "retient" au sens de notre fonction distance
		// soit approximativement avoir le moins possible de lettres diffrentes que ce mot
		// par contre, s'il y a peu de possibilits pour les "meilleurs" mots, on ajoute le reste
		// le reste : les mots ayant beaucoup de doublons, triplons, ... sont dans l'ordre nos prfrs
		// la constante 10 peut etre modifie (c'est constante_file)


// I) les 10 premiers mots en nb de possibilits minimal

		FilePriorite file_cryptee0 = new FilePriorite();
		int n_total = texteCrypte.size();
		int compteur = 0;
		int pourcentage = 0;
		for(String s : texteCrypte)
		{
			MotsPossibles.put(s, construitListeMot(s, p)); // p : permutation initiale pour l'analyse de frquence ; vide pour analyse brutale. on ne met que les mots possibles compatibles initialement avec cette analyse
			int n = MotsPossibles.get(s).size();
			System.out.println(s + "  " + n);
			if (n > 0)
				file_cryptee0.ajoute(s, -n, constante_file);
			
			if ((int) (100 * ((double) (compteur) / (double) (n_total))) != pourcentage && ((int) (100 * ((double) (compteur) / (double) (n_total)))) % 10 == 0)
				{pourcentage = (int) (100 * ((double) (compteur) / (double) (n_total)));
				System.out.println("\t\t\tetat : " + pourcentage + " %");};
			compteur++;
		}
		System.out.println("Creation des listes de mots possibles terminee.");
		System.out.println("temps liste mots (ms) : " + (System.currentTimeMillis() - temps1));

// II) les lettres manquantes

		// on ajoute  la queue de la file prcdente les mots qui contiennent des lettres encore inconnues
		boolean[] lettres2 = new boolean[26];
		for(int k = 0; k < 26; k++)
			lettres2[k] = false;
		NoeudPriorite noeud = file_cryptee0.deb;
		for(int k = 0; k < constante_file && noeud.suiv != null ; noeud = noeud.suiv, k++)
			for(int i = 0; i < noeud.s.length(); i++)
				lettres2[noeud.s.charAt(i) - 'a'] = true;
			
		int nbre = 0;
		for(int k = 0; k < 26; k++)
			if (lettres[k]) nbre++;
		nb_lettres_utilisees = nbre;
		
		int n = 0;
		for(int k = 0; k < 26; k++)
			if (lettres2[k]) n++;
		for(String s : texteCrypte)
		{
			if (s.length() > 1) // les mots de longueur 1 sont  dlaisser en premiere approche :
			for(int k = 0; k < s.length(); k++) // ils impliquent beaucoup de possibilits
			{
				if (!(lettres2[s.charAt(k) - 'a']))
				{	
					n++;
					lettres2[s.charAt(k) - 'a'] = true;
					file_cryptee0.ajoute_fin(s,1);
					if (n == nbre) break;
				}
			}
		};

		// idem pour les mots de longueur 1 qu'on a dlaisss plus tt
		if (n != nbre)
		for(String s : texteCrypte)
		{
			if (s.length() == 1)
				if (!(lettres2[s.charAt(0) - 'a']))
				{	
					n++;
					lettres2[s.charAt(0) - 'a'] = true;
					file_cryptee0.ajoute_fin(s,1);
					if (n == nbre) break;
				}
		};

// III) les mots  courte distance

		// si il y a encore trop de possibilits, on va intercaler entre le premier mot et les 9 autres minimaux,
		// 9 mots qui sont  courte distance du premier (i.e : utilisent presque les meme lettres)
		// (9 si constante_file faut 15)

		if ((-file_cryptee0.deb.suiv.suiv.priorite) >= 5)
		{
			retient = file_cryptee0.deb.s;
			NoeudPriorite debut0 = file_cryptee0.deb;
			FilePriorite file_cryptee1 = new FilePriorite();
			for(String s : texteCrypte)
				file_cryptee1.ajoute(s, -distance(retient, s), (int) (((double) constante_file) / 1.5));

			file_cryptee0.deb = file_cryptee0.deb.suiv;
			file_cryptee0.deb = file_cryptee1.fusion(file_cryptee0);
			debut0.suiv = file_cryptee0.deb;
			file_cryptee0.deb = debut0;
		}

// IV) les mots qui restent

		// les mots qui restent, rangs par ordre du nombre de doublons, triplons, ... (plus il y en a plus on les aime)
		FilePriorite file_cryptee2 = new FilePriorite();
		int valeur;
		for(String s : texteCrypte)
		{
			if (!(s.equals(retient)))
			{
				int nn = MotsPossibles.get(s).size();
				valeur = NoeudPriorite.calcule(s) * nn / (3 * nn * nn + 1);
				file_cryptee2.ajoute(s, valeur, 2 * constante_file);
			}
		}
		file_cryptee = file_cryptee0.fusion(file_cryptee2);
		System.out.println("ordre de parcours des mots :");
		for(NoeudPriorite noe = file_cryptee; noe.suiv != null; noe = noe.suiv)
			System.out.println(noe.s + " " + MotsPossibles.get(noe.s).size());

	}


// *********************************************************************************************************
// dbut de la partie des fonctions qui crent les listes de mots possibles

// les 7 fonctions qui suivent ne servent qu' crer la liste des mots possibles  partir
// du dictionnaire et d'un mot chiffr.
// exemple :  partir de ZERT la liste contiendra tous les mots de 4 lettres  4 lettres diffrentes

// pour rduire le temps de calcul, on sauvegarde dans une table de hashage les listes de mots possibles
// pour une "configuration" donne. ex : "toto" et "papa" ont la meme liste de mots possibles puisqu'ils
// sont gaux  une permutation prs
// la fonction hasher transforme donc "unabun" en "abcdab" et "pguvpg" en "abcdab" aussi
	public static String hasher(String mot) {
		int[] table = new int[26];
		int n = 0;

		for(int i = 0; i < 26; i++)
			table[i] = -1;

		for(int i = 0; i < mot.length(); i++)
			if (table[mot.charAt(i) - 'a'] < 0)
				table[mot.charAt(i) - 'a'] = n++;

		String retour = "";
		for(int i = 0; i < mot.length(); i++)
			retour += (char) (table[mot.charAt(i) - 'a'] + 'a');

		return retour;
	}

	public static LinkedList<permutation> transformer(LinkedList<permutation> liste, String ini, String fin) {
		LinkedList<permutation> retour = new LinkedList<permutation>();
		try{permutation modele = new permutation(fin, ini);
		for(permutation p : liste)
			retour.add(modele.composer(p));
		return retour;
		}
		catch(Exception e) {return null;}
	}

	public LinkedList<permutation> construitListeMot(String s, permutation p_ini){
		String calc = hasher(s);
		if (p_ini.nb_lettres == 0 && MotsPossibles.containsKey(calc))
			return transformer(MotsPossibles.get(calc), calc, s);

		if (p_ini.nb_lettres == 0 && !MotsPossibles.containsKey(calc))
			return new LinkedList<permutation>();

		LinkedList<permutation> l = MotsPossibles.containsKey(calc) ? MotsPossibles.get(calc) : new LinkedList<permutation>();

		LinkedList<permutation> resultat = new LinkedList<permutation>();
		
		for (permutation p : l)
		{
			try{
			if (permutation.compatible(p_ini, p))
				resultat.add((new permutation(s, calc)).composer(p));
			}
			catch(Exception e) {;}
		}

		return resultat;
	}

// fin de la partie des fonctions qui crent les listes de mots possibles
// *********************************************************************************************************


// les 2 fonctions qui suivent ne servent qu' afficher, soit dans la console, soit dans un fichier texte
// le rsultat d'une permutation sur le fichier chiffr
// affiche : la permutation, puis ce qu'elle "donne" sur le texte et enfin la liste des noms propres qui en dcoule

// affichage console
	public void show(permutation p) {

// calcul du vritable ratio
		int summ = 0, n = 0;
		for (String s : texteCrypteComplet)
		{
			n++;
			if (D_contient_mot(p.to_mot(s))) summ++;
		};

		System.out.println("cette permutation retranscrit " + (int) (((double) (summ) / (double) (n)) * 100) + " % des mots du texte crypte");
		System.out.println(p);
		for (String s : texteCrypteComplet)
			System.out.print(p.to_mot(s) + " ");
		System.out.println("\n\nListe des noms propres trouves :");
		boolean est_vide = true;
		for (String s : texteCrypteComplet)
			if (!D_contient_mot(p.to_mot(s)))
				{System.out.print(p.to_mot(s) + " "); est_vide = false;};
		if (est_vide) System.out.print("(aucun)");
		System.out.println("\n\n");
	}

// idem mais dans un fichier
	public void show(permutation p, BufferedWriter out) throws Exception {
	// calcul du vritable ratio
		int summ = 0, n = 0;
		for (String s : texteCrypteComplet)
		{
			n++;
			if (D_contient_mot(p.to_mot(s))) summ++;
		};

		out.write("cette permutation retranscrit " + (int) (((double) (summ) / (double) (n)) * 100) + " % des mots du texte crypte");
		out.newLine();
		out.write(p.toString());
		out.newLine();
		n = 0;
		for (String s : texteCrypteComplet)
		{
			out.write(p.to_mot(s) + " ");
			n++;
			if (n % 15 == 0) out.newLine(); // pour un affichage sur plusieurs lignes, dans notepad
		}
		out.newLine();
		out.newLine();
		out.write("Liste des noms propres trouves :");
		out.newLine();
		boolean est_vide = true;
		for (String s : texteCrypteComplet)
			if (!D_contient_mot(p.to_mot(s)))
				{out.write(p.to_mot(s) + " "); est_vide = false;};
		if (est_vide) out.write("(aucun)");
		out.newLine();
		out.newLine();
		out.write("##########################################");
		out.newLine();
		out.newLine();
	}
}