import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.filechooser.FileFilter;
import java.io.File;

class affichage extends JComponent implements ActionListener {

	String file_dico, dir_dico, file_crypt, text_crypt;
	int choix_lire_fichier_crypt;
	final int FICHIER = 1, SAISIE = 2, BRUT = 1, FREQUENCE = 2;
	decrypteur decryptator;
	boolean dico_change; // pour savoir s'il faut re-loader le dico entre chaque dcryptage

// utilis pour l'affichage seulement
    JFrame frame;
	JDialog F = new JDialog(new JDialog());
    JPanel panneau = new JPanel();
    JLabel choix_lb = new JLabel();
    JButton decrypter1 = new JButton(); // analyse simple
    JButton decrypter2 = new JButton(); // analyse frquence
    JButton decrypter3 = new JButton(); // analyse multilingue
    JButton quitter = new JButton();
    JLabel titre = new JLabel();
    JButton dico_bt = new JButton(); // pour un fichier dictionnaire
    JLabel dico_lb = new JLabel();
    JTextField dico_txt = new JTextField();
    JLabel dossier_dico_lb = new JLabel(); // pour un dossier de fichiers dictionnaires
    JTextField dossier_dico_txt = new JTextField();
    JButton dossier_dico_bt = new JButton();
    JButton crypt_bt = new JButton(); //le fichier  dcrypter
    JTextField crypt_txt = new JTextField();
    JLabel choix2_lb = new JLabel();
	JRadioButton crypt1_rb = new JRadioButton(); // le choix de saisie du fichier texte
	JRadioButton crypt2_rb = new JRadioButton();
	JTextArea entree_txt = new JTextArea(); // le texte saisi, ainsi que en dessous les barres de dfilement
	JScrollPane scrollPane = new JScrollPane(entree_txt, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

	affichage(JFrame fram) {
		frame = fram;
		dico_change  = true;
		file_dico = "";
		dir_dico = "";
		file_crypt = "";
		text_crypt = "";
		choix_lire_fichier_crypt = FICHIER;
		decryptator = new decrypteur();
		try {
		    jbInit();
			crypt1_rb.setSelected(true);
		}
	    catch (Exception e) {
			e.printStackTrace();
		}
    }



// gestion des vnements : clics sur les boutons, ...
	public void actionPerformed(ActionEvent ae){
		if(ae.getSource()== dico_bt){ // clic sur "selectionner un fichier dictionnaire"
			JFileChooser filebox = new JFileChooser();
			FiltreSimple data_filter = new FiltreSimple("Fichiers Data",".data");
			filebox.addChoosableFileFilter(data_filter);
			int returnVal = filebox.showOpenDialog(panneau);
			if(returnVal == JFileChooser.APPROVE_OPTION)
			{
				if (!(file_dico.equals(filebox.getSelectedFile().getPath())))
					dico_change = true;
				file_dico = filebox.getSelectedFile().getPath();
				dico_txt.setText(file_dico);
			}
		}
		if(ae.getSource()== dossier_dico_bt){ // clic sur "analyse multilingue"
			JFileChooser filebox = new JFileChooser();
			filebox.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			int returnVal = filebox.showOpenDialog(panneau);
			if(returnVal == JFileChooser.APPROVE_OPTION)
			{
				dir_dico = filebox.getSelectedFile().getPath();
				dossier_dico_txt.setText(dir_dico);
			}
		}
		else if(ae.getSource()== crypt_bt) // clic sur "selectionner le fichier  dcrypter"
		{ 
			JFileChooser filebox = new JFileChooser();
			int returnVal = filebox.showOpenDialog(panneau);
			if(returnVal == JFileChooser.APPROVE_OPTION)
			{
				file_crypt = filebox.getSelectedFile().getPath();
				crypt_txt.setText(file_crypt);
			}
		}
		else if(ae.getSource()== crypt1_rb) // clic sur "mode de selection = Fichier"
			choix_lire_fichier_crypt = FICHIER;
		else if(ae.getSource()== crypt2_rb) // clic sur "mode de selection = saisie manuelle"
			choix_lire_fichier_crypt = SAISIE;
		else if(ae.getSource() == quitter) // clic sur quitter
			frame.dispose();
		else if(ae.getSource() == decrypter1) // clic sur Decrypter normale
			lancer_decryptage(BRUT);
		else if(ae.getSource() == decrypter2) // clic sur Decrypter avec analyse frquentielle
			lancer_decryptage(FREQUENCE);
		else if(ae.getSource() == decrypter3) // clic sur Decrypter avec analyse multilingue
			decryptator.multilingue(dir_dico, file_crypt, choix_lire_fichier_crypt);
	}

// apres clic sur les boutons "lancer dcryptage" ; on ne traite pas ici l'analyse multilingue
	void lancer_decryptage(int mode) {
		long temps = System.currentTimeMillis();
		// gestion du fait que le dictionnaire est peu etre dja charg en mmoire
		if (dico_change)
				decryptator.load_dico(file_dico);
		dico_change = false;

		// gestion du mode de saisie du fichier crypt
		if (choix_lire_fichier_crypt == SAISIE)
			file_crypt = entree_txt.getText();
		else
			file_crypt = crypt_txt.getText();

		// gestion du mode de dcryptage : analyse pralable par frquence ou pas (constante BRUT) ?
		if (mode == BRUT)
			decryptator.analyse_brutale(file_crypt,choix_lire_fichier_crypt);
		else
			decryptator.analyse_frequence(file_crypt,choix_lire_fichier_crypt);
		
		// affichage des rsultats de l'analyse
		System.out.println("Analyse terminee.\n\n");
		System.out.println("Meilleure permutation :");
		decryptator.lector.show(decryptator.possibilites.last()); // permutation au meilleur ratio
		decryptator.affiche_possibilites(0.95); // dans un fichier texte
		System.out.println("temps total (ms) : " + (System.currentTimeMillis() - temps));
	}

// au dela de cette ligne, il n'y a que des instructions concernant le graphisme et la mise en page
// de cette fenetre
  	private void jbInit() throws Exception {
		panneau.setBackground(Color.lightGray);
		panneau.setBounds(new Rectangle(0, 1, 706, 605));
		panneau.setLayout(null);
		choix_lb.setFont(new java.awt.Font("Times New Roman", 0, 12));
		choix_lb.setText("Adresse des fichiers dictionnaires :");
		choix_lb.setBounds(new Rectangle(3, 54, 220, 32));
		dico_lb.setText("dictionnaire :");
		dico_lb.setBounds(new Rectangle(3, 90, 88, 20));
		dico_txt.setText("");
		dico_txt.setBounds(new Rectangle(93, 90, 220, 20));
		dico_txt.setEnabled(false);
		dico_bt.setBounds(new Rectangle(317, 90, 20, 20));
		dico_bt.setText("...");
		dico_bt.addActionListener(this);//ecouteur
		dossier_dico_lb.setText("dossier des dictionnaires :");
		dossier_dico_lb.setBounds(new Rectangle(3, 115, 150, 20));
		dossier_dico_txt.setText("");
		dossier_dico_txt.setBounds(new Rectangle(155, 115, 220, 20));
		dossier_dico_txt.setEnabled(false);
		dossier_dico_bt.setBounds(new Rectangle(380, 115, 20, 20));
		dossier_dico_bt.setText("...");
		dossier_dico_bt.addActionListener(this);//ecouteur
		choix2_lb.setFont(new java.awt.Font("Times New Roman", 0, 12));
		choix2_lb.setText("Mode d'entree du texte  decrypter :");
		choix2_lb.setBounds(new Rectangle(3, 140, 220, 20));
		crypt1_rb.setBounds(new Rectangle(3, 165, 130, 20));
		crypt1_rb.setText("fichier a dcrypter");
		crypt1_rb.addActionListener(this);//ecouteur
		crypt_txt.setText("");
		crypt_txt.setBounds(new Rectangle(138, 165, 220, 20));
		crypt_txt.setEnabled(false);
		crypt_bt.setBounds(new Rectangle(362, 165, 20, 20));
		crypt_bt.setText("...");
		crypt_bt.addActionListener(this);//ecouteur
		decrypter1.setText("Decrypter (simple)");
		decrypter1.addActionListener(this);//ecouteur
		decrypter1.setBounds(new Rectangle(70, 350, 150, 22));
		decrypter2.setText("Decrypter (frequence)");
		decrypter2.addActionListener(this);//ecouteur
		decrypter2.setBounds(new Rectangle(230, 350, 170, 22));
		decrypter3.setText("Decrypter (multilingue)");
		decrypter3.addActionListener(this);//ecouteur
		decrypter3.setBounds(new Rectangle(80, 380, 180, 22));
		quitter.setText("Quitter");
		quitter.setBounds(new Rectangle(270, 380, 108, 22));
		quitter.addActionListener(this);//ecouteur
		titre.setFont(new Font("DialogInput", 0, 16));
		titre.setForeground(SystemColor.textHighlight);
		titre.setText("Decrypteur");
		titre.setBounds(new Rectangle(205, 11, 184, 38));
		crypt2_rb.setBounds(new Rectangle(3, 190, 115, 20));
		crypt2_rb.setText("Texte a saisir");
		crypt2_rb.addActionListener(this);//ecouteur
		entree_txt.setLineWrap(true);
		entree_txt.setWrapStyleWord(true);
		entree_txt.setText("");
		entree_txt.setBounds(new Rectangle(125, 190, 325, 150));
		scrollPane.setBounds(new Rectangle(125, 190, 345, 150));
		scrollPane.getViewport().add(entree_txt, null);
		ButtonGroup group_rb = new ButtonGroup();
		group_rb.add(crypt1_rb);
		group_rb.add(crypt2_rb);
		panneau.add(choix_lb, null);
		panneau.add(titre, null);
		panneau.add(decrypter1, null);
		panneau.add(decrypter2, null);
		panneau.add(decrypter3, null);
		panneau.add(quitter, null);
		panneau.add(crypt_txt, null);
		panneau.add(dico_lb, null);
		panneau.add(dico_txt, null);
		panneau.add(dico_bt, null);
		panneau.add(dossier_dico_lb, null);
		panneau.add(dossier_dico_txt, null);
		panneau.add(dossier_dico_bt, null);
		panneau.add(crypt_bt, null);
		panneau.add(crypt1_rb, null);
		panneau.add(crypt2_rb, null);
		panneau.add(choix2_lb, null);
		panneau.add(scrollPane, null);

		F.getContentPane().add(this);
		this.add(panneau, null);
		F.setSize(new Dimension(485, 440));
	}

}

// cette classe est utilise pour agrmenter la boite de dialogue d'ouverture du fichier dictionnaire
class FiltreSimple extends FileFilter{

   //Description et extension accepte par le filtre
   private String description;
   private String extension;

   //Constructeur  partir de la description et de l'extension accepte
   public FiltreSimple(String description, String extension){
      if(description == null || extension ==null){ // n'est pas sens arriver
         throw new NullPointerException("La description (ou extension) ne peut tre null.");
      }
      this.description = description;
      this.extension = extension;
   }

   //Implmentation de FileFilter
   public boolean accept(File file){
      if(file.isDirectory()) { 
         return true; 
      } 
      String nomFichier = file.getName().toLowerCase(); 

      return nomFichier.endsWith(extension);
   }
      public String getDescription(){
      return description;
   }
}

